/* SQL Manager 2005 for InterBase and Firebird 4.1.0.3                                                             */
/* --------------------------------------------------------------------------------------------------------------- */
/* Host     : localhost                                                                                            */
/* Database : C:\Arquivos de programas\Apache Software Foundation\Tomcat 6.0\webapps\sistemaGrFM\banco\RADIOGR.GDB */


CREATE DATABASE 'C:\Arquivos de programas\Apache Software Foundation\Tomcat 6.0\webapps\sistemaGrFM\banco\RADIOGR.GDB'
   USER 'SYSDBA'
   PAGE_SIZE 4096
   DEFAULT CHARACTER SET NONE;

/* Definition for the `BOOLEAN` domain :  */

CREATE DOMAIN BOOLEAN AS
  CHAR(1) CHARACTER SET ASCII
  DEFAULT 'F'
  CHECK ((VALUE IN ('T','F')) OR (VALUE IS NULL))
  COLLATE ASCII;

/* Definition for the `COMMENT` domain :  */

CREATE DOMAIN "COMMENT" AS
  BLOB SUB_TYPE 1 CHARACTER SET UNICODE_FSS
  COLLATE UNICODE_FSS;

/* Definition for the `TIPOPESSOA` domain :  */

CREATE DOMAIN TIPOPESSOA AS
  CHAR(1) CHARACTER SET WIN1251
  CHECK (((VALUE IS NULL) OR (VALUE = 'F') OR (VALUE = 'J')))
  COLLATE WIN1251;

/* Definition for the `BRNCODG_GEN` generator :  */

CREATE GENERATOR BRNCODG_GEN;

/* Definition for the `CDNCODG_GEN` generator :  */

CREATE GENERATOR CDNCODG_GEN;

/* Definition for the `EMNCODG_GEN` generator :  */

CREATE GENERATOR EMNCODG_GEN;

/* Definition for the `EPNCODG_GEN` generator :  */

CREATE GENERATOR EPNCODG_GEN;

/* Definition for the `FNNCODG_GEN` generator :  */

CREATE GENERATOR FNNCODG_GEN;

/* Definition for the `GDNCODG_GEN` generator :  */

CREATE GENERATOR GDNCODG_GEN;

/* Definition for the `GONCODG_GEN` generator :  */

CREATE GENERATOR GONCODG_GEN;

/* Definition for the `GRNCODG_GEN` generator :  */

CREATE GENERATOR GRNCODG_GEN;

/* Definition for the `LGNCODG_GEN` generator :  */

CREATE GENERATOR LGNCODG_GEN;

/* Definition for the `MNNCOD2_GEN` generator :  */

CREATE GENERATOR MNNCOD2_GEN;

/* Definition for the `MNNCODG_GEN` generator :  */

CREATE GENERATOR MNNCODG_GEN;

/* Definition for the `MSNCODG_GEN` generator :  */

CREATE GENERATOR MSNCODG_GEN;

/* Definition for the `OPNCOD2_GEN` generator :  */

CREATE GENERATOR OPNCOD2_GEN;

/* Definition for the `OPNCODG_GEN` generator :  */

CREATE GENERATOR OPNCODG_GEN;

/* Definition for the `PENCODG_GEN` generator :  */

CREATE GENERATOR PENCODG_GEN;

/* Definition for the `PRNCODG_GEN` generator :  */

CREATE GENERATOR PRNCODG_GEN;

/* Definition for the `PSNCODG_GEN` generator :  */

CREATE GENERATOR PSNCODG_GEN;

/* Definition for the `RENCODG_GEN` generator :  */

CREATE GENERATOR RENCODG_GEN;

/* Definition for the `TFNCODG_GEN` generator :  */

CREATE GENERATOR TFNCODG_GEN;

/* Definition for the `TLNCODG_GEN` generator :  */

CREATE GENERATOR TLNCODG_GEN;

/* Definition for the `UGNCODG_GEN` generator :  */

CREATE GENERATOR UGNCODG_GEN;

/* Definition for the `UONCODG_GEN` generator :  */

CREATE GENERATOR UONCODG_GEN;

/* Definition for the `USNCODG_GEN` generator :  */

CREATE GENERATOR USNCODG_GEN;

/* Structure for the `PAIS` table :  */

CREATE TABLE PAIS (
  PSNCODG INTEGER NOT NULL,
  PSCDESC VARCHAR(30) CHARACTER SET WIN1251 NOT NULL COLLATE WIN1251,
  PSCDDI VARCHAR(5) CHARACTER SET WIN1251 COLLATE WIN1251,
  PSNDDI INTEGER);


ALTER TABLE PAIS ADD CONSTRAINT UQ_PAIS UNIQUE (PSCDESC);

ALTER TABLE PAIS ADD CONSTRAINT PK_PAIS PRIMARY KEY (PSNCODG);


/* Structure for the `ESTADOPROVINCIA` table :  */

CREATE TABLE ESTADOPROVINCIA (
  EPNCODG INTEGER NOT NULL,
  EPNCGPS INTEGER NOT NULL,
  EPCDESC VARCHAR(30) CHARACTER SET WIN1251 NOT NULL COLLATE WIN1251,
  EPCUF VARCHAR(2) CHARACTER SET WIN1251 NOT NULL COLLATE WIN1251);


ALTER TABLE ESTADOPROVINCIA ADD CONSTRAINT UQ_ESTADOPROVINCIA1 UNIQUE (EPNCGPS,EPCDESC);

ALTER TABLE ESTADOPROVINCIA ADD CONSTRAINT UQ_ESTADOPROVINCIA2 UNIQUE (EPNCGPS,EPCDESC,EPCUF);

ALTER TABLE ESTADOPROVINCIA ADD CONSTRAINT PK_ESTADOPROVINCIA1 PRIMARY KEY (EPNCODG);

ALTER TABLE ESTADOPROVINCIA ADD CONSTRAINT FK_EPPS FOREIGN KEY (EPNCGPS) REFERENCES PAIS(PSNCODG);


/* Structure for the `CIDADE` table :  */

CREATE TABLE CIDADE (
  CDNCODG INTEGER NOT NULL,
  CDNCGEP INTEGER NOT NULL,
  CDCDESC VARCHAR(50) CHARACTER SET WIN1251 NOT NULL COLLATE WIN1251);


ALTER TABLE CIDADE ADD CONSTRAINT UQ_CIDADE UNIQUE (CDNCGEP,CDCDESC);

ALTER TABLE CIDADE ADD CONSTRAINT PK_CIDADE PRIMARY KEY (CDNCODG);

ALTER TABLE CIDADE ADD CONSTRAINT FK_CDEP FOREIGN KEY (CDNCGEP) REFERENCES ESTADOPROVINCIA(EPNCODG);


/* Structure for the `BAIRRO` table :  */

CREATE TABLE BAIRRO (
  BRNCODG INTEGER NOT NULL,
  BRNCGCD INTEGER NOT NULL,
  BRCDESC VARCHAR(50) CHARACTER SET WIN1251 NOT NULL COLLATE WIN1251);


ALTER TABLE BAIRRO ADD CONSTRAINT UQ_BAIRRO UNIQUE (BRNCGCD,BRCDESC);

ALTER TABLE BAIRRO ADD CONSTRAINT PK_BAIRRO PRIMARY KEY (BRNCODG);

ALTER TABLE BAIRRO ADD CONSTRAINT FK_BRCD FOREIGN KEY (BRNCGCD) REFERENCES CIDADE(CDNCODG);


/* Structure for the `PESSOA` table :  */

CREATE TABLE PESSOA (
  PENCODG INTEGER NOT NULL,
  PECNOME VARCHAR(60) CHARACTER SET WIN1251 NOT NULL COLLATE WIN1251,
  PECNFAP VARCHAR(40) CHARACTER SET WIN1251 COLLATE WIN1251,
  PECTIPO TIPOPESSOA NOT NULL,
  PECCPFJ VARCHAR(14) CHARACTER SET WIN1251 COLLATE WIN1251,
  PEIFOTO BLOB);


ALTER TABLE PESSOA ADD CONSTRAINT PK_PESSOA PRIMARY KEY (PENCODG);


/* Structure for the `CONTATO` table :  */

CREATE TABLE CONTATO (
  CTNCODG INTEGER NOT NULL,
  CTNCGPE INTEGER NOT NULL,
  CTCNOME VARCHAR(50) CHARACTER SET WIN1251 NOT NULL COLLATE WIN1251,
  CTCFUNC VARCHAR(50) CHARACTER SET WIN1251 COLLATE WIN1251,
  CTDNASC DATE,
  CTCFON1 VARCHAR(10) CHARACTER SET WIN1251 COLLATE WIN1251,
  CTCFON2 VARCHAR(10) CHARACTER SET WIN1251 COLLATE WIN1251,
  CTCMAIL VARCHAR(80) CHARACTER SET WIN1251 COLLATE WIN1251,
  CTCMATR VARCHAR(15) CHARACTER SET WIN1251 COLLATE WIN1251,
  CTNCOMS FLOAT);


ALTER TABLE CONTATO ADD CONSTRAINT FK_CONTATO PRIMARY KEY (CTNCODG);

ALTER TABLE CONTATO ADD CONSTRAINT FK_CTPE FOREIGN KEY (CTNCGPE) REFERENCES PESSOA(PENCODG);


/* Structure for the `CLIENTE` table :  */

CREATE TABLE CLIENTE (
  CLNCODG INTEGER NOT NULL,
  CLNCGCT INTEGER NOT NULL,
  CLNCGPE INTEGER NOT NULL,
  CLNC2PE INTEGER NOT NULL);


ALTER TABLE CLIENTE ADD CONSTRAINT UQ_CLIENTE UNIQUE (CLNCGCT,CLNCGPE,CLNC2PE);

ALTER TABLE CLIENTE ADD CONSTRAINT FK_CLIENTE PRIMARY KEY (CLNCODG);

ALTER TABLE CLIENTE ADD CONSTRAINT FK_CLCT FOREIGN KEY (CLNCGCT) REFERENCES CONTATO(CTNCODG) ON UPDATE CASCADE;

ALTER TABLE CLIENTE ADD CONSTRAINT FK_CLPE1 FOREIGN KEY (CLNCGPE) REFERENCES PESSOA(PENCODG) ON UPDATE CASCADE;

ALTER TABLE CLIENTE ADD CONSTRAINT FK_CLPE2 FOREIGN KEY (CLNC2PE) REFERENCES PESSOA(PENCODG) ON UPDATE CASCADE;


/* Structure for the `CONTRATO` table :  */

CREATE TABLE CONTRATO (
  CRNCODG INTEGER NOT NULL,
  CRNCGPE INTEGER NOT NULL,
  CRNCGCL INTEGER NOT NULL,
  CRCRAMO VARCHAR(100) CHARACTER SET WIN1251 COLLATE WIN1251,
  CRMTEXT "COMMENT",
  CRDINIC DATE NOT NULL,
  CRDTERM DATE NOT NULL,
  CRNVALR FLOAT NOT NULL,
  CRNDESC FLOAT,
  CRNFPAG INTEGER,
  CRNCPAG INTEGER,
  CRBCANC BOOLEAN,
  CRDCANC TIMESTAMP,
  CRNCOMS FLOAT);


ALTER TABLE CONTRATO ADD CONSTRAINT FK_CONTRATO PRIMARY KEY (CRNCODG);

ALTER TABLE CONTRATO ADD CONSTRAINT FK_CRCL FOREIGN KEY (CRNCGCL) REFERENCES CLIENTE(CLNCODG) ON UPDATE CASCADE;

ALTER TABLE CONTRATO ADD CONSTRAINT FK_CRPE FOREIGN KEY (CRNCGPE) REFERENCES PESSOA(PENCODG) ON UPDATE CASCADE;


/* Structure for the `EMAIL` table :  */

CREATE TABLE EMAIL (
  EMNCODG INTEGER NOT NULL,
  EMNCGPE INTEGER NOT NULL,
  EMCDESC VARCHAR(50) CHARACTER SET WIN1251 NOT NULL COLLATE WIN1251);


ALTER TABLE EMAIL ADD CONSTRAINT PK_EMAIL PRIMARY KEY (EMNCODG);

ALTER TABLE EMAIL ADD CONSTRAINT FK_EMPE FOREIGN KEY (EMNCGPE) REFERENCES PESSOA(PENCODG) ON UPDATE CASCADE;


/* Structure for the `TIPOLOGRADOURO` table :  */

CREATE TABLE TIPOLOGRADOURO (
  TLNCODG INTEGER NOT NULL,
  TLCDESC VARCHAR(50) CHARACTER SET WIN1251 NOT NULL COLLATE WIN1251,
  TLBDEFT BOOLEAN);


ALTER TABLE TIPOLOGRADOURO ADD CONSTRAINT PK_TIPOLOGRADOURO PRIMARY KEY (TLNCODG);


/* Structure for the `LOGRADOURO` table :  */

CREATE TABLE LOGRADOURO (
  LGNCODG INTEGER NOT NULL,
  LGNCGBR INTEGER NOT NULL,
  LGNCGTL INTEGER NOT NULL,
  LGCDESC VARCHAR(50) CHARACTER SET WIN1251 COLLATE WIN1251,
  LGCCEP VARCHAR(8) CHARACTER SET WIN1251 COLLATE WIN1251);


ALTER TABLE LOGRADOURO ADD CONSTRAINT PK_LOGRADOURO PRIMARY KEY (LGNCODG);

ALTER TABLE LOGRADOURO ADD CONSTRAINT FK_LGBR FOREIGN KEY (LGNCGBR) REFERENCES BAIRRO(BRNCODG);

ALTER TABLE LOGRADOURO ADD CONSTRAINT FK_LGTL FOREIGN KEY (LGNCGTL) REFERENCES TIPOLOGRADOURO(TLNCODG);


/* Structure for the `ENDERECO` table :  */

CREATE TABLE ENDERECO (
  EDNCODG INTEGER NOT NULL,
  EDNCGPE INTEGER NOT NULL,
  EDNCGLG INTEGER,
  EDNCGTL INTEGER,
  EDNCGCD INTEGER,
  EDCBAIR VARCHAR(60) CHARACTER SET WIN1251 COLLATE WIN1251,
  EDCLOGR VARCHAR(80) CHARACTER SET WIN1251 COLLATE WIN1251,
  EDCNUMR VARCHAR(10) CHARACTER SET WIN1251 COLLATE WIN1251,
  EDCCOMP VARCHAR(60) CHARACTER SET WIN1251 COLLATE WIN1251,
  EDBPRIN CHAR(1) CHARACTER SET WIN1251 COLLATE WIN1251,
  EDCCEP VARCHAR(8) CHARACTER SET WIN1251 COLLATE WIN1251);


ALTER TABLE ENDERECO ADD CONSTRAINT CHK_ENDERECO CHECK (
((EDNCGLG IS NULL) AND (EDNCGTL IS NOT NULL) AND (EDNCGCD IS NOT NULL)) OR
((EDNCGLG IS NOT NULL) AND (EDNCGTL IS NULL) AND(EDNCGCD IS NULL))
);

ALTER TABLE ENDERECO ADD CONSTRAINT PK_ENDERECO PRIMARY KEY (EDNCODG);

ALTER TABLE ENDERECO ADD CONSTRAINT FK_EDCD FOREIGN KEY (EDNCGCD) REFERENCES CIDADE(CDNCODG) ON DELETE SET NULL ON UPDATE CASCADE;

ALTER TABLE ENDERECO ADD CONSTRAINT FK_EDLG FOREIGN KEY (EDNCGLG) REFERENCES LOGRADOURO(LGNCODG);

ALTER TABLE ENDERECO ADD CONSTRAINT FK_EDPE FOREIGN KEY (EDNCGPE) REFERENCES PESSOA(PENCODG);

ALTER TABLE ENDERECO ADD CONSTRAINT FK_EDTL FOREIGN KEY (EDNCGTL) REFERENCES TIPOLOGRADOURO(TLNCODG) ON DELETE SET NULL ON UPDATE CASCADE;


/* Structure for the `TIPOFONE` table :  */

CREATE TABLE TIPOFONE (
  TFNCODG INTEGER NOT NULL,
  TFCDESC VARCHAR(50) CHARACTER SET WIN1251 NOT NULL COLLATE WIN1251);


ALTER TABLE TIPOFONE ADD CONSTRAINT PK_TIPOFONE PRIMARY KEY (TFNCODG);


/* Structure for the `FONE` table :  */

CREATE TABLE FONE (
  FNNCODG INTEGER NOT NULL,
  FNNCGPE INTEGER NOT NULL,
  FNCDESC VARCHAR(50) CHARACTER SET WIN1251 NOT NULL COLLATE WIN1251,
  FNNCGTF INTEGER NOT NULL);


ALTER TABLE FONE ADD CONSTRAINT PK_FONE PRIMARY KEY (FNNCODG);

ALTER TABLE FONE ADD CONSTRAINT FK_FNPE FOREIGN KEY (FNNCGPE) REFERENCES PESSOA(PENCODG) ON UPDATE CASCADE;

ALTER TABLE FONE ADD CONSTRAINT FK_FNTF FOREIGN KEY (FNNCGTF) REFERENCES TIPOFONE(TFNCODG);


/* Structure for the `GERADOR` table :  */

CREATE TABLE GERADOR (
  GDCDESC VARCHAR(40) CHARACTER SET WIN1251 NOT NULL COLLATE WIN1251,
  GDNVALR INTEGER NOT NULL);


ALTER TABLE GERADOR ADD CONSTRAINT PK_GERADOR PRIMARY KEY (GDCDESC);


/* Structure for the `GRUPO` table :  */

CREATE TABLE GRUPO (
  GRNCODG INTEGER NOT NULL,
  GRCDESC VARCHAR(30) CHARACTER SET WIN1251 NOT NULL COLLATE WIN1251,
  GRBCANC BOOLEAN,
  GRNCGPE INTEGER NOT NULL);


ALTER TABLE GRUPO ADD CONSTRAINT PK_GRUPO PRIMARY KEY (GRNCODG);

ALTER TABLE GRUPO ADD CONSTRAINT FK_GRPE FOREIGN KEY (GRNCGPE) REFERENCES PESSOA(PENCODG) ON UPDATE CASCADE;


/* Structure for the `OPERACAO` table :  */

CREATE TABLE OPERACAO (
  OPNCODG INTEGER NOT NULL,
  OPNCGOP INTEGER,
  OPNCOD2 INTEGER NOT NULL,
  OPCDESC VARCHAR(60) CHARACTER SET WIN1251 NOT NULL COLLATE WIN1251,
  OPCFORM VARCHAR(30) CHARACTER SET WIN1251 NOT NULL COLLATE WIN1251,
  OPCACFR VARCHAR(80) CHARACTER SET WIN1251 NOT NULL COLLATE WIN1251,
  OPBCANC BOOLEAN,
  OPNULTM INTEGER NOT NULL);


ALTER TABLE OPERACAO ADD CONSTRAINT PK_OPERACAO PRIMARY KEY (OPNCODG);

ALTER TABLE OPERACAO ADD CONSTRAINT FK_OPOP FOREIGN KEY (OPNCGOP) REFERENCES OPERACAO(OPNCODG);


/* Structure for the `GRUPOPER` table :  */

CREATE TABLE GRUPOPER (
  GONCODG INTEGER NOT NULL,
  GONCGGR INTEGER NOT NULL,
  GONCGOP INTEGER NOT NULL);


ALTER TABLE GRUPOPER ADD CONSTRAINT UQ_GRUPOPER UNIQUE (GONCGGR,GONCGOP);

ALTER TABLE GRUPOPER ADD CONSTRAINT PK_GRUPOPER PRIMARY KEY (GONCODG);

ALTER TABLE GRUPOPER ADD CONSTRAINT FK_GOGR FOREIGN KEY (GONCGGR) REFERENCES GRUPO(GRNCODG) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE GRUPOPER ADD CONSTRAINT FK_GOOP FOREIGN KEY (GONCGOP) REFERENCES OPERACAO(OPNCODG) ON DELETE CASCADE ON UPDATE CASCADE;


/* Structure for the `PROGRAMA` table :  */

CREATE TABLE PROGRAMA (
  PGNCODG INTEGER NOT NULL,
  PGNCGPE INTEGER NOT NULL,
  PGCDESC VARCHAR(60) CHARACTER SET WIN1251 NOT NULL COLLATE WIN1251,
  PGYVALR FLOAT NOT NULL,
  PGNDURC INTEGER NOT NULL);


ALTER TABLE PROGRAMA ADD CONSTRAINT PK_PROGRAMA PRIMARY KEY (PGNCODG);

ALTER TABLE PROGRAMA ADD CONSTRAINT FK_PGPE FOREIGN KEY (PGNCGPE) REFERENCES PESSOA(PENCODG);


/* Structure for the `HORARIO` table :  */

CREATE TABLE HORARIO (
  HRNCODG INTEGER NOT NULL,
  HRNSDIA INTEGER NOT NULL,
  HRHINIC TIME NOT NULL,
  HRHTERM TIME NOT NULL,
  HRNCGPG INTEGER NOT NULL);


ALTER TABLE HORARIO ADD CONSTRAINT PK_HORARIO PRIMARY KEY (HRNCODG);

ALTER TABLE HORARIO ADD CONSTRAINT FK_HRPG FOREIGN KEY (HRNCGPG) REFERENCES PROGRAMA(PGNCODG);


/* Structure for the `INSERCAO` table :  */

CREATE TABLE INSERCAO (
  INNCODG INTEGER NOT NULL,
  INNCGCR INTEGER NOT NULL,
  INNCGPG INTEGER NOT NULL,
  INDDATA DATE NOT NULL,
  INNVALR FLOAT NOT NULL,
  INNDURA FLOAT NOT NULL,
  INNQTD INTEGER NOT NULL);


ALTER TABLE INSERCAO ADD CONSTRAINT FK_INSERCAO PRIMARY KEY (INNCODG);

ALTER TABLE INSERCAO ADD CONSTRAINT FK_INCR FOREIGN KEY (INNCGCR) REFERENCES CONTRATO(CRNCODG) ON UPDATE CASCADE;

ALTER TABLE INSERCAO ADD CONSTRAINT FK_INPG FOREIGN KEY (INNCGPG) REFERENCES PROGRAMA(PGNCODG) ON UPDATE CASCADE;


/* Structure for the `USUARIO` table :  */

CREATE TABLE USUARIO (
  USNCODG INTEGER NOT NULL,
  USCLOGN VARCHAR(20) CHARACTER SET NONE NOT NULL COLLATE NONE,
  USCSENH VARCHAR(32) CHARACTER SET NONE NOT NULL COLLATE NONE,
  USNCGPE INTEGER NOT NULL);


ALTER TABLE USUARIO ADD CONSTRAINT UQ_USCLOGN UNIQUE (USCLOGN);

ALTER TABLE USUARIO ADD CONSTRAINT UQ_USNCGPE UNIQUE (USNCGPE);

ALTER TABLE USUARIO ADD CONSTRAINT PK_USUARIO PRIMARY KEY (USNCODG);

ALTER TABLE USUARIO ADD CONSTRAINT FK_USPE FOREIGN KEY (USNCGPE) REFERENCES PESSOA(PENCODG) ON UPDATE CASCADE;


/* Structure for the `LOG` table :  */

CREATE TABLE LOG (
  LGNCODG INTEGER NOT NULL,
  LGNCGUS INTEGER NOT NULL,
  LGCREHT VARCHAR(60) CHARACTER SET WIN1251 NOT NULL COLLATE WIN1251,
  LGDENTR TIMESTAMP NOT NULL,
  LGDSAID TIMESTAMP,
  LGNCGPE INTEGER NOT NULL);


ALTER TABLE LOG ADD CONSTRAINT PK_LOG PRIMARY KEY (LGNCODG);

ALTER TABLE LOG ADD CONSTRAINT FK_LGPE FOREIGN KEY (LGNCGPE) REFERENCES PESSOA(PENCODG) ON UPDATE CASCADE;

ALTER TABLE LOG ADD CONSTRAINT FK_LGUS FOREIGN KEY (LGNCGUS) REFERENCES USUARIO(USNCODG);


/* Structure for the `MENU` table :  */

CREATE TABLE MENU (
  MNNCODG INTEGER NOT NULL,
  MNNCGMN INTEGER,
  MNNCOD2 INTEGER NOT NULL,
  MNCDESC VARCHAR(60) CHARACTER SET WIN1251 NOT NULL COLLATE WIN1251,
  MNCDICA VARCHAR(60) CHARACTER SET WIN1251 COLLATE WIN1251,
  MNCTIPO VARCHAR(60) CHARACTER SET WIN1251 COLLATE WIN1251,
  MNCIDCO VARCHAR(30) CHARACTER SET WIN1251 COLLATE WIN1251,
  MNCHREF VARCHAR(60) CHARACTER SET WIN1251 COLLATE WIN1251,
  MNMOBS "COMMENT",
  MNNCGOP INTEGER,
  MNNULTM INTEGER NOT NULL,
  MNCFUNC VARCHAR(30) CHARACTER SET WIN1251 COLLATE WIN1251,
  MNCTARG BOOLEAN);


ALTER TABLE MENU ADD CONSTRAINT UQ_MENU UNIQUE (MNNCGMN,MNNCOD2);

ALTER TABLE MENU ADD CONSTRAINT UQ_MNCIDCO UNIQUE (MNCIDCO);

ALTER TABLE MENU ADD CONSTRAINT PK_MENU PRIMARY KEY (MNNCODG);

ALTER TABLE MENU ADD CONSTRAINT FK_MNMN FOREIGN KEY (MNNCGMN) REFERENCES MENU(MNNCODG);

ALTER TABLE MENU ADD CONSTRAINT FK_MNOP FOREIGN KEY (MNNCGOP) REFERENCES OPERACAO(OPNCODG);


/* Structure for the `MESSAGEM` table :  */

CREATE TABLE MESSAGEM (
  MSNCODG INTEGER NOT NULL,
  MSNCGPE INTEGER NOT NULL,
  MSCCHAV VARCHAR(50) CHARACTER SET WIN1251 NOT NULL COLLATE WIN1251,
  MSCVALR VARCHAR(50) CHARACTER SET WIN1251 NOT NULL COLLATE WIN1251,
  MSMDESC "COMMENT");


ALTER TABLE MESSAGEM ADD CONSTRAINT UQ_MESSAGEM UNIQUE (MSNCGPE,MSCCHAV);

ALTER TABLE MESSAGEM ADD CONSTRAINT PK_MESSAGEM PRIMARY KEY (MSNCODG);

ALTER TABLE MESSAGEM ADD CONSTRAINT FK_MSPE FOREIGN KEY (MSNCGPE) REFERENCES PESSOA(PENCODG) ON UPDATE CASCADE;


/* Structure for the `META` table :  */

CREATE TABLE META (
  MTNCODG INTEGER NOT NULL,
  MTNCGCT INTEGER NOT NULL,
  MTNANO INTEGER NOT NULL);


ALTER TABLE META ADD CONSTRAINT UQ_META UNIQUE (MTNCGCT,MTNANO);

ALTER TABLE META ADD CONSTRAINT FK_META PRIMARY KEY (MTNCODG);

ALTER TABLE META ADD CONSTRAINT FK_MTCT FOREIGN KEY (MTNCGCT) REFERENCES CONTATO(CTNCODG) ON UPDATE CASCADE;


/* Structure for the `METAMES` table :  */

CREATE TABLE METAMES (
  MMNCODG INTEGER NOT NULL,
  MMNCGMT INTEGER NOT NULL,
  MMNMES INTEGER NOT NULL,
  MMNVALR FLOAT NOT NULL);


ALTER TABLE METAMES ADD CONSTRAINT UQ_METAMES UNIQUE (MMNCGMT,MMNMES);

ALTER TABLE METAMES ADD CONSTRAINT FK_METAMES PRIMARY KEY (MMNCODG);

ALTER TABLE METAMES ADD CONSTRAINT FK_MMMT FOREIGN KEY (MMNCGMT) REFERENCES META(MTNCODG) ON UPDATE CASCADE;


/* Structure for the `PESSOAFISICA` table :  */

CREATE TABLE PESSOAFISICA (
  PFNCODG INTEGER NOT NULL,
  PFNCGPE INTEGER NOT NULL,
  PFCRG VARCHAR(15) CHARACTER SET WIN1251 COLLATE WIN1251,
  PFCOERG VARCHAR(10) CHARACTER SET WIN1251 COLLATE WIN1251,
  PFNEPRG INTEGER,
  PFDNASC TIMESTAMP,
  PFNCGGI INTEGER,
  PFNCGEV INTEGER,
  PFCSEXO CHAR(1) CHARACTER SET WIN1251 COLLATE WIN1251,
  PFCPAI VARCHAR(50) CHARACTER SET WIN1251 COLLATE WIN1251,
  PFCMAE VARCHAR(50) CHARACTER SET WIN1251 COLLATE WIN1251,
  PFCCONJ VARCHAR(50) CHARACTER SET WIN1251 COLLATE WIN1251);


ALTER TABLE PESSOAFISICA ADD CONSTRAINT UQ_PFNCGPE UNIQUE (PFNCGPE);

ALTER TABLE PESSOAFISICA ADD CONSTRAINT PK_PESSOAFISICA PRIMARY KEY (PFNCODG);

ALTER TABLE PESSOAFISICA ADD CONSTRAINT FK_PFPE FOREIGN KEY (PFNCGPE) REFERENCES PESSOA(PENCODG);


/* Structure for the `PESSOAJURIDICA` table :  */

CREATE TABLE PESSOAJURIDICA (
  PJNCODG INTEGER NOT NULL,
  PJNCGPE INTEGER NOT NULL,
  PJCIE VARCHAR(20) CHARACTER SET WIN1251 COLLATE WIN1251,
  PJNEPIE INTEGER,
  PJCTIPO CHAR(1) CHARACTER SET WIN1251 COLLATE WIN1251);


ALTER TABLE PESSOAJURIDICA ADD CONSTRAINT UQ_PJNCGPE UNIQUE (PJNCGPE);

ALTER TABLE PESSOAJURIDICA ADD CONSTRAINT PK_PESSOAJURIDICA PRIMARY KEY (PJNCODG);

ALTER TABLE PESSOAJURIDICA ADD CONSTRAINT FK_PJPE FOREIGN KEY (PJNCGPE) REFERENCES PESSOA(PENCODG);


/* Structure for the `RELACAO` table :  */

CREATE TABLE RELACAO (
  RENCODG INTEGER NOT NULL,
  RECDESC VARCHAR(50) CHARACTER SET WIN1251 NOT NULL COLLATE WIN1251);


ALTER TABLE RELACAO ADD CONSTRAINT PK_RELACAO PRIMARY KEY (RENCODG);


/* Structure for the `PESSOARELACAO` table :  */

CREATE TABLE PESSOARELACAO (
  PRNCODG INTEGER NOT NULL,
  PRNCGPE INTEGER NOT NULL,
  PRNC2PE INTEGER NOT NULL,
  PRNCGRE INTEGER NOT NULL,
  PRDCADT TIMESTAMP NOT NULL,
  PRBCANC BOOLEAN,
  PRDCANC TIMESTAMP);


ALTER TABLE PESSOARELACAO ADD CONSTRAINT PK_PESSOARELACAO PRIMARY KEY (PRNCODG);

ALTER TABLE PESSOARELACAO ADD CONSTRAINT FK_PRPE FOREIGN KEY (PRNCGPE) REFERENCES PESSOA(PENCODG) ON UPDATE CASCADE;

ALTER TABLE PESSOARELACAO ADD CONSTRAINT FK_PRPE2 FOREIGN KEY (PRNC2PE) REFERENCES PESSOA(PENCODG) ON UPDATE CASCADE;

ALTER TABLE PESSOARELACAO ADD CONSTRAINT FK_PRRE FOREIGN KEY (PRNCGRE) REFERENCES RELACAO(RENCODG) ON UPDATE CASCADE;


/* Structure for the `USUGROP` table :  */

CREATE TABLE USUGROP (
  UGNCODG INTEGER NOT NULL,
  UGNCGUS INTEGER NOT NULL,
  UGNCGGR INTEGER NOT NULL);


ALTER TABLE USUGROP ADD CONSTRAINT UQ_USUGROP UNIQUE (UGNCGUS,UGNCGGR);

ALTER TABLE USUGROP ADD CONSTRAINT PK_USUGROP PRIMARY KEY (UGNCODG);

ALTER TABLE USUGROP ADD CONSTRAINT FK_UGGR FOREIGN KEY (UGNCGGR) REFERENCES GRUPO(GRNCODG) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE USUGROP ADD CONSTRAINT FK_UGUS FOREIGN KEY (UGNCGUS) REFERENCES USUARIO(USNCODG) ON DELETE CASCADE ON UPDATE CASCADE;


/* Structure for the `USUOPER` table :  */

CREATE TABLE USUOPER (
  UONCODG INTEGER NOT NULL,
  UONCGUS INTEGER NOT NULL,
  UONCGOP INTEGER NOT NULL,
  UONCGPE INTEGER NOT NULL);


ALTER TABLE USUOPER ADD CONSTRAINT UQ_USUOPER UNIQUE (UONCGUS,UONCGOP);

ALTER TABLE USUOPER ADD CONSTRAINT PK_USUOPER PRIMARY KEY (UONCODG);

ALTER TABLE USUOPER ADD CONSTRAINT FK_UOOP FOREIGN KEY (UONCGOP) REFERENCES OPERACAO(OPNCODG) ON UPDATE CASCADE;

ALTER TABLE USUOPER ADD CONSTRAINT FK_UOPE FOREIGN KEY (UONCGPE) REFERENCES PESSOA(PENCODG) ON UPDATE CASCADE;

ALTER TABLE USUOPER ADD CONSTRAINT FK_UOUS FOREIGN KEY (UONCGUS) REFERENCES USUARIO(USNCODG) ON UPDATE CASCADE;


/* Definition for the `BI_BRNCODG` trigger :  */

SET TERM ^ ;

CREATE TRIGGER BI_BRNCODG FOR BAIRRO
ACTIVE AFTER 
POSITION 0
AS
^

SET TERM ; ^

/* Definition for the `BI_CDNCODG` trigger :  */

SET TERM ^ ;

CREATE TRIGGER BI_CDNCODG FOR CIDADE
ACTIVE AFTER 
POSITION 0
AS
^

SET TERM ; ^

/* Definition for the `BI_EMNCODG` trigger :  */

SET TERM ^ ;

CREATE TRIGGER BI_EMNCODG FOR EMAIL
ACTIVE AFTER 
POSITION 0
AS
^

SET TERM ; ^

/* Definition for the `BI_EPNCODG` trigger :  */

SET TERM ^ ;

CREATE TRIGGER BI_EPNCODG FOR ESTADOPROVINCIA
ACTIVE AFTER 
POSITION 0
AS
^

SET TERM ; ^

/* Definition for the `BI_FNNCODG` trigger :  */

SET TERM ^ ;

CREATE TRIGGER BI_FNNCODG FOR FONE
ACTIVE AFTER 
POSITION 0
AS
^

SET TERM ; ^

/* Definition for the `BI_GDNVALR` trigger :  */

SET TERM ^ ;

CREATE TRIGGER BI_GDNVALR FOR GERADOR
ACTIVE AFTER 
POSITION 0
AS
^

SET TERM ; ^

/* Definition for the `BI_GONCODG` trigger :  */

SET TERM ^ ;

CREATE TRIGGER BI_GONCODG FOR GRUPOPER
ACTIVE AFTER 
POSITION 0
AS
^

SET TERM ; ^

/* Definition for the `BI_GRNCODG` trigger :  */

SET TERM ^ ;

CREATE TRIGGER BI_GRNCODG FOR GRUPO
ACTIVE AFTER 
POSITION 0
AS
^

SET TERM ; ^

/* Definition for the `BI_LGDENTR` trigger :  */

SET TERM ^ ;

CREATE TRIGGER BI_LGDENTR FOR LOG
ACTIVE AFTER 
POSITION 0
AS
^

SET TERM ; ^

/* Definition for the `BI_LGNCODG` trigger :  */

SET TERM ^ ;

CREATE TRIGGER BI_LGNCODG FOR LOG
ACTIVE AFTER 
POSITION 0
AS
^

SET TERM ; ^

/* Definition for the `BI_MNNCOD2` trigger :  */

SET TERM ^ ;

CREATE TRIGGER BI_MNNCOD2 FOR MENU
ACTIVE AFTER 
POSITION 0
AS
^

SET TERM ; ^

/* Definition for the `BI_MNNCODG` trigger :  */

SET TERM ^ ;

CREATE TRIGGER BI_MNNCODG FOR MENU
ACTIVE AFTER 
POSITION 0
AS
^

SET TERM ; ^

/* Definition for the `BI_MNNULTM` trigger :  */

SET TERM ^ ;

CREATE TRIGGER BI_MNNULTM FOR MENU
ACTIVE AFTER 
POSITION 0
AS
^

SET TERM ; ^

/* Definition for the `BI_MSNCODG` trigger :  */

SET TERM ^ ;

CREATE TRIGGER BI_MSNCODG FOR MESSAGEM
ACTIVE AFTER 
POSITION 0
AS
^

SET TERM ; ^

/* Definition for the `BI_OPNCOD2` trigger :  */

SET TERM ^ ;

CREATE TRIGGER BI_OPNCOD2 FOR OPERACAO
ACTIVE AFTER 
POSITION 0
AS
^

SET TERM ; ^

/* Definition for the `BI_OPNCODG` trigger :  */

SET TERM ^ ;

CREATE TRIGGER BI_OPNCODG FOR OPERACAO
ACTIVE AFTER 
POSITION 0
AS
^

SET TERM ; ^

/* Definition for the `BI_OPNULTM` trigger :  */

SET TERM ^ ;

CREATE TRIGGER BI_OPNULTM FOR OPERACAO
ACTIVE AFTER 
POSITION 0
AS
^

SET TERM ; ^

/* Definition for the `BI_PENCODG` trigger :  */

SET TERM ^ ;

CREATE TRIGGER BI_PENCODG FOR PESSOA
ACTIVE AFTER 
POSITION 0
AS
^

SET TERM ; ^

/* Definition for the `BI_PRBCADT` trigger :  */

SET TERM ^ ;

CREATE TRIGGER BI_PRBCADT FOR PESSOARELACAO
ACTIVE AFTER 
POSITION 0
AS
^

SET TERM ; ^

/* Definition for the `BI_PRDCADT` trigger :  */

SET TERM ^ ;

CREATE TRIGGER BI_PRDCADT FOR PESSOARELACAO
ACTIVE AFTER 
POSITION 0
AS
^

SET TERM ; ^

/* Definition for the `BI_PRNCODG` trigger :  */

SET TERM ^ ;

CREATE TRIGGER BI_PRNCODG FOR PESSOARELACAO
ACTIVE AFTER 
POSITION 0
AS
^

SET TERM ; ^

/* Definition for the `BI_PSNCODG` trigger :  */

SET TERM ^ ;

CREATE TRIGGER BI_PSNCODG FOR PAIS
ACTIVE AFTER 
POSITION 0
AS
^

SET TERM ; ^

/* Definition for the `BI_RENCODG` trigger :  */

SET TERM ^ ;

CREATE TRIGGER BI_RENCODG FOR RELACAO
ACTIVE AFTER 
POSITION 0
AS
^

SET TERM ; ^

/* Definition for the `BI_TFNCODG` trigger :  */

SET TERM ^ ;

CREATE TRIGGER BI_TFNCODG FOR TIPOFONE
ACTIVE AFTER 
POSITION 0
AS
^

SET TERM ; ^

/* Definition for the `BI_TLNCODG` trigger :  */

SET TERM ^ ;

CREATE TRIGGER BI_TLNCODG FOR TIPOLOGRADOURO
ACTIVE AFTER 
POSITION 0
AS
^

SET TERM ; ^

/* Definition for the `BI_UGNCODG` trigger :  */

SET TERM ^ ;

CREATE TRIGGER BI_UGNCODG FOR USUGROP
ACTIVE AFTER 
POSITION 0
AS
^

SET TERM ; ^

/* Definition for the `BI_UONCODG` trigger :  */

SET TERM ^ ;

CREATE TRIGGER BI_UONCODG FOR USUOPER
ACTIVE AFTER 
POSITION 0
AS
^

SET TERM ; ^

/* Definition for the `BI_USNCODG` trigger :  */

SET TERM ^ ;

CREATE TRIGGER BI_USNCODG FOR USUARIO
ACTIVE AFTER 
POSITION 0
AS
^

SET TERM ; ^

/* Definition for the `BU_PRDCANC` trigger :  */

SET TERM ^ ;

CREATE TRIGGER BU_PRDCANC FOR PESSOARELACAO
ACTIVE AFTER 
POSITION 0
AS
^

SET TERM ; ^

GRANT SELECT, INSERT, DELETE, REFERENCES, UPDATE ON PAIS TO SYSDBA WITH GRANT OPTION;
GRANT SELECT, INSERT, DELETE, REFERENCES, UPDATE ON ESTADOPROVINCIA TO SYSDBA WITH GRANT OPTION;
GRANT SELECT, INSERT, DELETE, REFERENCES, UPDATE ON CIDADE TO SYSDBA WITH GRANT OPTION;
GRANT SELECT, INSERT, DELETE, REFERENCES, UPDATE ON BAIRRO TO SYSDBA WITH GRANT OPTION;
GRANT SELECT, INSERT, DELETE, REFERENCES, UPDATE ON PESSOA TO SYSDBA WITH GRANT OPTION;
GRANT SELECT, INSERT, DELETE, REFERENCES, UPDATE ON CONTATO TO SYSDBA WITH GRANT OPTION;
GRANT SELECT, INSERT, DELETE, REFERENCES, UPDATE ON CLIENTE TO SYSDBA WITH GRANT OPTION;
GRANT SELECT, INSERT, DELETE, REFERENCES, UPDATE ON CONTRATO TO SYSDBA WITH GRANT OPTION;
GRANT SELECT, INSERT, DELETE, REFERENCES, UPDATE ON EMAIL TO SYSDBA WITH GRANT OPTION;
GRANT SELECT, INSERT, DELETE, REFERENCES, UPDATE ON TIPOLOGRADOURO TO SYSDBA WITH GRANT OPTION;
GRANT SELECT, INSERT, DELETE, REFERENCES, UPDATE ON LOGRADOURO TO SYSDBA WITH GRANT OPTION;
GRANT SELECT, INSERT, DELETE, REFERENCES, UPDATE ON ENDERECO TO SYSDBA WITH GRANT OPTION;
GRANT SELECT, INSERT, DELETE, REFERENCES, UPDATE ON TIPOFONE TO SYSDBA WITH GRANT OPTION;
GRANT SELECT, INSERT, DELETE, REFERENCES, UPDATE ON FONE TO SYSDBA WITH GRANT OPTION;
GRANT SELECT, INSERT, DELETE, REFERENCES, UPDATE ON GERADOR TO SYSDBA WITH GRANT OPTION;
GRANT SELECT, INSERT, DELETE, REFERENCES, UPDATE ON GRUPO TO SYSDBA WITH GRANT OPTION;
GRANT SELECT, INSERT, DELETE, REFERENCES, UPDATE ON OPERACAO TO SYSDBA WITH GRANT OPTION;
GRANT SELECT, INSERT, DELETE, REFERENCES, UPDATE ON GRUPOPER TO SYSDBA WITH GRANT OPTION;
GRANT SELECT, INSERT, DELETE, REFERENCES, UPDATE ON PROGRAMA TO SYSDBA WITH GRANT OPTION;
GRANT SELECT, INSERT, DELETE, REFERENCES, UPDATE ON HORARIO TO SYSDBA WITH GRANT OPTION;
GRANT SELECT, INSERT, DELETE, REFERENCES, UPDATE ON INSERCAO TO SYSDBA WITH GRANT OPTION;
GRANT SELECT, INSERT, DELETE, REFERENCES, UPDATE ON USUARIO TO SYSDBA WITH GRANT OPTION;
GRANT SELECT, INSERT, DELETE, REFERENCES, UPDATE ON LOG TO SYSDBA WITH GRANT OPTION;
GRANT SELECT, INSERT, DELETE, REFERENCES, UPDATE ON MENU TO SYSDBA WITH GRANT OPTION;
GRANT SELECT, INSERT, DELETE, REFERENCES, UPDATE ON MESSAGEM TO SYSDBA WITH GRANT OPTION;
GRANT SELECT, INSERT, DELETE, REFERENCES, UPDATE ON META TO SYSDBA WITH GRANT OPTION;
GRANT SELECT, INSERT, DELETE, REFERENCES, UPDATE ON METAMES TO SYSDBA WITH GRANT OPTION;
GRANT SELECT, INSERT, DELETE, REFERENCES, UPDATE ON PESSOAFISICA TO SYSDBA WITH GRANT OPTION;
GRANT SELECT, INSERT, DELETE, REFERENCES, UPDATE ON PESSOAJURIDICA TO SYSDBA WITH GRANT OPTION;
GRANT SELECT, INSERT, DELETE, REFERENCES, UPDATE ON RELACAO TO SYSDBA WITH GRANT OPTION;
GRANT SELECT, INSERT, DELETE, REFERENCES, UPDATE ON PESSOARELACAO TO SYSDBA WITH GRANT OPTION;
GRANT SELECT, INSERT, DELETE, REFERENCES, UPDATE ON USUGROP TO SYSDBA WITH GRANT OPTION;
GRANT SELECT, INSERT, DELETE, REFERENCES, UPDATE ON USUOPER TO SYSDBA WITH GRANT OPTION;

